HDU 5670

Machine

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 163    Accepted Submission(s): 99

Problem Description

There is a machine with m(2≤m≤30)

coloured bulbs and a button.When the button is pushed, the rightmost bulb changes.
For any changed bulb,

if it is red now it will be green;

if it is green now it will be blue;

if it is blue now it will be red and the bulb that on the left(if it exists) will change too.

Initally all the bulbs are red. What colour are the bulbs after the button be
pushed n(1≤n<263)

times?

Input

There are multiple test cases. The first line of input contains an integer T(1≤T≤15)

indicating the number of test cases. For each test case:

The only line contains two integers m(2≤m≤30)

and n(1≤n<263)

.

Output

For each test case, output the colour of m bulbs from left to right.
R indicates red. G indicates green. B indicates blue.

Sample Input

2
3 1
2 3

Sample Output

RRG
GR

Source

BestCoder Round #81 (div.2)

题意:有一个机器,它有 m(2≤m≤30)m (2\leq m\leq 30)m(2≤m≤30) 个彩灯和一个按钮。每按下按钮时,最右边的彩灯会发生一次变换。变换为:

1. 如果当前状态为红色,它将变成绿色;

2.如果当前状态为绿色,它将变成蓝色;

3.如果当前状态为蓝色,它将变成红色,并且它左边的彩灯(如果存在)也会发生一次变换。

初始状态下所有的灯都是红色的。
询问按下按钮 n(1≤n<263)n (1\leq n< {2}^{63})n(1≤n<2?63??) 次以后各个彩灯的颜色。

题解: 可以转换为求 n%(3^m)的三进制数

 1  #include<iostream>
 2  #include<cstring>
 3  #include<cstdio>
 4  #include<queue>
 5  #include<stack>
 6  #include<map>
 7  #include<set>
 8  #include<algorithm>
 9  #define ll __int64
10  #define pi acos(-1.0)
11  #define mod 1
12  #define maxn 10000
13  using namespace std;
14  int t;
15  map<int,char> mp;
16  ll n;
17  int m;
18  int b[35];
19  int main()
20  {
21      mp[0]=‘R‘;
22      mp[1]=‘G‘;
23      mp[2]=‘B‘;
24      scanf("%d",&t);
25      for(int i=1;i<=t;i++)
26      {
27          scanf("%d %I64d",&m,&n);
28          int k=0;
29          for(int j=0;j<=31;j++)
30           b[j]=0;
31          ll exm=1;
32           for(int i=1;i<=m;i++)
33              exm*=3;
34         if(n>=exm)
35             n=n%exm;
36          while(n)
37          {
38              b[k]=n%3;
39              n/=3;
40              k++;
41         }
42         if(k<m)
43         {
44
45             for(int j=m;j>k;j--)
46              cout<<"R";
47              for(int j=k-1;j>=0;j--)
48              printf("%c",mp[b[j]]);
49         }
50         else
51         {
52          for(int j=k-1;j>=k-m;j--)
53          printf("%c",mp[b[j]]);
54         }
55         cout<<endl;
56 }
57      return 0;
58  }
时间: 2024-12-19 23:38:41

HDU 5670的相关文章

hdu 5670 Machine(BC规律题)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5670 Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 451    Accepted Submission(s): 266 Problem Description There is a machine with m(2≤m≤

HDU 5670 Machine

Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 290    Accepted Submission(s): 179 Problem Description There is a machine with m(2≤m≤30) coloured bulbs and a button.When the button is pu

签到 2016.5.10

1.HDU 5670 Machine 解题思路: 变化的规律为红 -> 绿 -> 蓝 -> 红 将红.绿.蓝分别表示0.1.2 原问题就转化为求 n 的三进制表示的最低的 m 位,即求n mod 3^m??的三进制表示 复杂度 O(m) #include <iostream> #include <cstdio> using namespace std; typedef long long LL; const int maxn = 30 + 5; char s[ma

HDU 1058 Humble Numbers(离线打表)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1058 解题报告:输入一个n,输出第n个质因子只有2,3,5,7的数. 用了离线打表,因为n最大只有5842. 1 #include<stdio.h> 2 #define INT __int64 3 INT ans[5850] = { 4 0,1,2,3,4,5,6,7,8,9,10,12,14,15,16,18,20,21,24,25,27,28,30,32,35,36,40,42,45,48,4

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是